<?php
/**
 * Created by PhpStorm.
 * User: sscho
 * Date: 13/01/2018
 * Time: 19:45
 */

namespace Pmg\Includes;

/**************************
 *
 *  Maps
 *
 *************************/

class Functions {
// function for the custom type
	public static function create_post_type_map() {
		// creating (registering) the custom type
		register_post_type( 'maps',
			// let's now add all the options for this post type
			array(
				'labels'              => array(
					'name'               => __( 'Maps', 'pu-map-geo' ),
					/* This is the Title of the Group */
					'singular_name'      => __( 'Map', 'pu-map-geo' ),
					/* This is the individual type */
					'all_items'          => __( 'All maps', 'pu-map-geo' ),
					/* the all items menu item */
					'add_new'            => __( 'New map', 'pu-map-geo' ),
					/* The add new menu item */
					'add_new_item'       => __( 'Add new map', 'pu-map-geo' ),
					/* Add New Display Title */
					'edit'               => __( 'Edit', 'pu-map-geo' ),
					/* Edit Dialog */
					'edit_item'          => __( 'Edit map', 'pu-map-geo' ),
					/* Edit Display Title */
					'new_item'           => __( 'Mew map', 'pu-map-geo' ),
					/* New Display Title */
					'view_item'          => __( 'View map', 'pu-map-geo' ),
					/* View Display Title */
					'search_items'       => __( 'Find map', 'pu-map-geo' ),
					/* Search Custom Type Title */
					'not_found'          => __( 'No maps found in database', 'pu-map-geo' ),
					/* This displays if there are no entries yet */
					'not_found_in_trash' => __( 'Nothing found in trash', 'pu-map-geo' ),
					/* This displays if there is nothing in the trash */
					'parent_item_colon'  => ''
				),
				/* end of arrays */
				'description'         => __( 'Maps constructed with open layers', 'pu-map-geo' ),
				/* Custom Type Description */
				'public'              => true,
				'publicly_queryable'  => true,
				'exclude_from_search' => false,
				'show_ui'             => true,
				'query_var'           => true,
				'menu_position'       => 9,
				/* this is what order you want it to appear in on the left hand side menu */
				'menu_icon'           => plugins_url() . '/puddinq-map-geo/img/custom-post-icon.png',
				/* the icon for the custom post type menu */
				'rewrite'             => array( 'slug' => 'map', 'with_front' => false ),
				/* you can specify its url slug */
				'has_archive'         => 'maps',
				/* you can rename the slug here */
				'capability_type'     => 'post',
				'hierarchical'        => true,
				/* the next one is important, it tells what's enabled in the post editor */
				'supports'            => array(
					'title',
					'post-formats',
					'editor',
					'author',
					'thumbnail',
					'excerpt',
					'trackbacks',
					'custom-fields',
					'comments',
					'revisions',
					'sticky'
				)
			) /* end of options */
		); /* end of register post type */

		/* this adds your post categories to your custom post type */
		//register_taxonomy_for_object_type( 'category', 'ongelukken' );
		/* this adds your post tags to your custom post type */
		//register_taxonomy_for_object_type( 'post_tag', 'ongelukken' );

	}

	public static function puddinq_map_geo_content_filter($content) {

	if (!is_admin() && is_singular( 'maps' )) {
		$content = sprintf(
			'<div id="map" class="map"></div>
             <li>
                <label id="layer0" class="checkbox" for="visible0">
                    <input id="visible0" class="visible" type="checkbox"/> Openstraatmap
                </label>
             </li>
             <li>
                <label id="layer1" class="checkbox" for="visible1">
                    <input id="visible1" class="visible" type="checkbox"/> Afval
                </label>
             </li>
             <li>
                <label id="layer2" class="checkbox" for="visible2">
                    <input id="visible2" class="visible" type="checkbox"/> stadsdelen
                </label>
             </li>
             <li>
                <label id="layer3" class="checkbox" for="visible3">
                    <input id="visible3" class="visible" type="checkbox"/> gemeente
                </label>
             </li>
             <li>
                <label id="layer4" class="checkbox" for="visible4">
                    <input id="visible4" class="visible" type="checkbox"/> hondlosloop
                </label>
             </li>
             <li>
                <label id="layer5" class="checkbox" for="visible5">
                    <input id="visible5" class="visible" type="checkbox"/> buurt
                </label>
             </li>
             <li>
                <label id="layer6" class="checkbox" for="visible6">
                    <input id="visible6" class="visible" type="checkbox"/> panden
                </label>
             </li>
             <li>
                <label id="layer7" class="checkbox" for="visible7">
                    <input id="visible7" class="visible" type="checkbox"/> woonplaats
                </label>
             </li>
             <li>
                <label id="layer8" class="checkbox" for="visible8">
                    <input id="visible8" class="visible" type="checkbox"/> Gebouwen
                </label>
             </li>
             <pre class="log-container"><code id="log"></code></pre>%s', $content
		);
	}

	return $content;
	}

}