// puddinq map geo
// License: http://www.wtfpl.net/
// Version: v0.0.1

var pud_map_geo;

(function ($, root, undefined) {

    'use strict';

    jQuery(document).ready(function() {

        /**
         * create the map
         */
        var url = 'http://wfs.haarlem.nl:80/geoserver/gemeentehaarlem/wfs';
        console.table(pud_map_geo);
        var longitude = parseFloat(pud_map_geo.long);
        var latitude = parseFloat(pud_map_geo.latt);


        /**
         *      afval
         * @type {ol.source.Vector}
         */

        var afvalsource = new ol.source.Vector({
            format: new ol.format.GeoJSON(),
            url: function(extent) {
                return 'https://wfs.haarlem.nl/ows?service=WFS' +
                '&version=2.0.0&request=GetFeature&typename=afvalinzamel' +
                '&featuretype=plastic&outputFormat=application/json&srsname=EPSG:3857&' +
                'bbox=' + extent.join(',') + ',EPSG:3857';
            },
            strategy: ol.loadingstrategy.bbox
        });

        var afval = new ol.layer.Vector({
            source: afvalsource,
            style: new ol.style.Style({
                stroke: new ol.style.Stroke({
                    color: '#319FD3',
                    width: 2
                }),
                image: new ol.style.Circle({
                    radius: 3,
                    fill: new ol.style.Fill({color: 'white'})
                })
            })
        });

        /**
         *      hondlosloop
         * @type {ol.source.Vector}
         */
        var hondlosloop = new ol.source.Vector({
            format: new ol.format.GeoJSON(),
            url: function(extent) {
                return 'https://wfs.haarlem.nl/ows?service=WFS' +
                '&version=2.0.0&request=GetFeature&typename=hondlosloop' +
                '&outputFormat=application/json&srsname=EPSG:3857&' +
                'bbox=' + extent.join(',') + ',EPSG:3857';
            },
            strategy: ol.loadingstrategy.bbox
        });

        var hondlosloop = new ol.layer.Vector({
            source: hondlosloop,
            style: new ol.style.Style({
                stroke: new ol.style.Stroke({
                    color: 'yellow',
                    width: 1
                }),
                fill: new ol.style.Fill({
                    color: 'rgba(255, 255, 0, 0.1)'
                })
            })
        });

        /**
         *      gemeente
         * @type {ol.source.Vector}
         */
        var gemeenteSource = new ol.source.Vector({
            url: 'https://wfs.haarlem.nl/ows?service=WFS&version=2.0.0&request=GetFeature&typename=gemeentegrens&outputFormat=application/json&srsname=EPSG:3857',
            format: new ol.format.GeoJSON()
        });

        var gemeente = new ol.layer.Vector({
            source: gemeenteSource,
            style: new ol.style.Style({
                stroke: new ol.style.Stroke({
                    color: 'red',
                    width: 2
                }),
                image: new ol.style.Circle({
                    radius: 3,
                    fill: new ol.style.Fill({color: 'white'})
                })
            })
        });


        /**
         *      stadsdelen
         * @type {ol.source.Vector}
         */

        var stadsdelenSource = new ol.source.Vector({
            format: new ol.format.GeoJSON(),
            url: function(extent) {
                return 'https://wfs.haarlem.nl/ows?service=WFS&version=2.0.0&request=GetFeature&typename=stadsdeel&outputFormat=application/json&srsname=EPSG:3857&' +
                    'bbox=' + extent.join(',') + ',EPSG:3857';
            },
            strategy: ol.loadingstrategy.bbox
        });
        var stadsdelen = new ol.layer.Vector({
            source: stadsdelenSource,
            style: new ol.style.Style({
                stroke: new ol.style.Stroke({
                    color: '#319FD3',
                    width: 2
                }),
                image: new ol.style.Circle({
                    radius: 3,
                    fill: new ol.style.Fill({color: 'white'})
                })
            })
        });
        var raster = new ol.layer.Tile({
            source: new ol.source.BingMaps({
                imagerySet: 'Road',
                key: 'AuR-3BKnYGj7anf74lsV5BHsvdcU1hSCKMwYWXigQ1LrJEk19ywBiFp8Jty1i_6W'
            })
        });

        /**
         *      panden
         * @type {ol.source.Vector}
         */
        var pandenSource = new ol.source.Vector({
            format: new ol.format.GeoJSON(),
            url: function(extent) {
                return 'https://geodata.nationaalgeoregister.nl/bag/wfs?' +
                    'version=2.0.0&request=GetFeature&typename=pand' +
                    '&outputFormat=application/json&srsname=EPSG:3857&' +
                    'bbox=' + extent.join(',') + ',EPSG:3857';
            },
            strategy: ol.loadingstrategy.bbox
        });

        var panden = new ol.layer.Vector({
            source: pandenSource,
            style: new ol.style.Style({
                stroke: new ol.style.Stroke({
                    color: 'black',
                    width: 2
                }),
                fill: new ol.style.Fill({
                    color: 'rgba(255, 255, 0, 0.1)'
                })
            })
        });

        /**
         *      woonplaats
         * @type {ol.source.Vector}
         */
        var woonplaatsSource = new ol.source.Vector({
            format: new ol.format.GeoJSON(),
            url: function(extent) {
                return 'https://geodata.nationaalgeoregister.nl/bag/wfs?' +
                    'version=2.0.0&request=GetFeature&typename=woonplaats' +
                    '&outputFormat=application/json&srsname=EPSG:3857&' +
                    'bbox=' + extent.join(',') + ',EPSG:3857';
            },
            strategy: ol.loadingstrategy.bbox
        });

        var woonplaats = new ol.layer.Vector({
            source: woonplaatsSource,
            style: new ol.style.Style({
                stroke: new ol.style.Stroke({
                    color: 'black',
                    width: 2
                }),
                fill: new ol.style.Fill({
                    color: 'rgba(255, 255, 0, 0.1)'
                })
            })
        });

        var raster = new ol.layer.Tile({
            source: new ol.source.BingMaps({
                imagerySet: 'Road',
                key: 'AuR-3BKnYGj7anf74lsV5BHsvdcU1hSCKMwYWXigQ1LrJEk19ywBiFp8Jty1i_6W'
            })
        });

        /**
         *      buurt
         * @type {ol.source.Vector}
         */
        var buurtSource = new ol.source.Vector({
            url: 'https://wfs.haarlem.nl/ows?service=WFS&version=2.0.0&request=GetFeature&typename=buurt&outputFormat=application/json&srsname=EPSG:3857',
            format: new ol.format.GeoJSON()
        });

        var buurt = new ol.layer.Vector({
            source: buurtSource,
            style: new ol.style.Style({
                stroke: new ol.style.Stroke({
                    color: '#319FD3',
                    width: 2
                }),
                image: new ol.style.Circle({
                    radius: 3,
                    fill: new ol.style.Fill({color: 'white'})
                })
            })
        });
        var raster = new ol.layer.Tile({
            source: new ol.source.OSM()
        });
        var center = ol.proj.transform([longitude, latitude], 'EPSG:4326','EPSG:3857');
        console.log(center);

        var view = new ol.View({
            center: center,
            zoom: 15
        })

        var wmsSource = new ol.source.TileWMS({
            url: 'http://wfs.haarlem.nl/geoserver/gemeentehaarlem/ows',
            params: {'LAYERS': 'bag_pand'},
            serverType: 'geoserver',
            crossOrigin: 'anonymous',
        });

        var gebouwen = new ol.layer.Tile({
            source: wmsSource
        });

        var map = new ol.Map({
            layers: [raster, afval, stadsdelen, gemeente, hondlosloop, buurt, panden, woonplaats, gebouwen],
            target: document.getElementById('map'),
            view: view
        });
        
        function bindInputs(layerid, layer) {
            var visibilityInput = $(layerid + ' input.visible');
            visibilityInput.on('change', function() {
                layer.setVisible(this.checked);
            });
            visibilityInput.prop('checked', layer.getVisible());
        }
        
        map.getLayers().forEach(function(layer, i) {
            bindInputs('#layer' + i, layer);
        });

        map.on('singleclick', function(evt) {
            document.getElementById('log').innerHTML = '';
            var viewResolution = /** @type {number} */ (view.getResolution());
            var url = wmsSource.getGetFeatureInfoUrl(
                evt.coordinate, viewResolution, 'EPSG:3857',
                {'INFO_FORMAT': 'text/html'});
            if (url) {
                document.getElementById('log').innerHTML =
                    '<iframe seamless src="' + url + '"></iframe>';
            }
        });

    })

})(jQuery, this);
